#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int N = 3e5 + 5;
array<int, N> tin, tout, s, posney, lp, p;
vector<int> g[N];
vector<int> ney;
int T = 0;

void dfs1(int v) {
    tin[v] = T++;
    for (auto to: g[v]) {
        if (g[v].size() > 1)
            lp[to] = v;
        else
            lp[to] = lp[v];
        dfs1(to);
    }
    tout[v] = T;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    for (int i = 2; i <= n; i++) {
        int x;
        cin >> x;
        p[i] = x;
        g[x].push_back(i);
    }
    dfs1(1);
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }
    set<pair<int, int>> st = {{s[1], 1}};
    while (!st.empty()) {
        auto it = prev(st.end());
        auto [val, v] = *it;
        st.erase(it);
        ney.push_back(v);
        for (auto to: g[v]) {
            st.insert({s[to], to});
        }
    }

    vector<int> qr(q), ans(q);
    for (int i = 0; i < ney.size(); i++) {
        posney[ney[i]] = i;
    }
    vector<int> t(2 * n + 1);
    auto add = [&](int i, int x) {
        i += n;
        t[i] += x;
        while (i > 1) {
            i >>= 1;
            t[i] = t[i << 1] + t[(i << 1) | 1];
        }
    };
    auto gsum = [&](int r) {
        int l = n;
        r += n;
        int ret = 0;
        while (l < r) {
            if (l & 1) {
                ret += t[l++];
            }
            if (r & 1)
                ret += t[--r];
            l >>= 1;
            r >>= 1;
        }
        return ret;
    };
    //vector<tuple<int, int, int, int>> quer;
    int qernt = 0;
    vector<int> qidq;
    vector<tuple<int, int, int, int>> scamline;
    for (int id = 0; id < q; id++) {
        cin >> qr[id];
        int v = lp[qr[id]];
        while (v != 0) {
            for (auto to: g[v]) {
                if (tin[to] <= tin[qr[id]] && tout[to] >= tout[qr[id]])continue;
                // quer.emplace_back(tin[to], tout[to] - 1, posney[qr[id]], quer.size());
                scamline.emplace_back(tin[to], -1, posney[qr[id]], qernt);
                scamline.emplace_back(tout[to] - 1, 1, posney[qr[id]], qernt);
                qernt++;
                qidq.push_back(id);
            }
            v = lp[v];
        }
    }
    vector<int> qans(qernt);

    //          l/r1  type r2 qid
    for (int i = 1; i <= n; i++) {
        scamline.emplace_back(tin[i], 0, posney[i], 1);
    }
    std::sort(scamline.begin(), scamline.end());
    t.assign(2 * n + 1, 0);
    for (auto [x, type, r2, qid]: scamline) {
        if (type == 0) {
            add(r2, qid);
            continue;
        }
        if (type == 1) {
            qans[qid] += gsum(r2);
        } else {
            qans[qid] -= gsum(r2);
        }
    }
    for (int i = 0; i < qidq.size(); i++) {
        ans[qidq[i]] = max(ans[qidq[i]], qans[i]);
    }
    for (int i = 0; i < q; i++) {
        cout << posney[qr[i]] - ans[i] << ' ';
    }
    return 0;
}
/*
1. эйлеров обход
2. обход который в задаче ney
    поддерживаем сет вершин берем макс из сета и добавляем его детей в сет

3. пробуем удалять поддеревья
 для какой-то вершины v
 тогда ответ изменится на 1кол-во вершин одновременно лежащих в поддереве и в обходе до v
    3.1
        кол-во точек в прямоугольнике - это кол-во в прямоугольниуке тоут - тин-1


        5 4
1 2 2 1
3 5 1 2 4
3 1 4 5


 5 5
 1 2 3 4
 1  2 3  4 5
  1 2 3 4 5
 */